package zero1hd.rhythmbullet.graphics.ui.components;

import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.g2d.BitmapFont;
import com.badlogic.gdx.graphics.g2d.GlyphLayout;
import com.badlogic.gdx.scenes.scene2d.ui.Label;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;

public class ShortenedTextLabel extends Label {
	private String originalText;
	private int targetWidth;
	private GlyphLayout gl;
	private BitmapFont font;
	
	public ShortenedTextLabel(CharSequence text, Skin skin, String fontName, Color color) {
		super(text, skin, fontName, color);
		originalText = text.toString();
		font = skin.getFont(fontName);
		if (text != null) {
			gl = new GlyphLayout(skin.getFont(fontName), text);
		}
	}
	
	public void setTargetWidth(int targetWidth) {
		this.targetWidth = targetWidth;
	}
	
	@Override
	public void act(float delta) {
		super.act(delta);
	}
	
	public void resize() {
		setToOriginalText();
		while (gl.width > targetWidth && (getText().length - 4) > 0) {
			setText(getText().substring(0, getText().length - 4).concat("..."));
			gl.setText(font, getText());
		}
	}
	
	public void setToOriginalText() {
		setText(originalText);
		gl.setText(font, originalText);
	}
	
	@Override
	public void layout() {
		super.layout();
	}
	
	public void setOriginalText(String originalText) {
		this.originalText = originalText;
		gl.setText(font, originalText);
	}
	
	public int getTargetWidth() {
		return targetWidth;
	}
}
