package zero1hd.rhythmbullet.graphics.ui.pages;

import com.badlogic.gdx.assets.AssetManager;
import com.badlogic.gdx.graphics.g2d.TextureAtlas;
import com.badlogic.gdx.math.Vector3;
import com.badlogic.gdx.scenes.scene2d.Actor;
import com.badlogic.gdx.scenes.scene2d.ui.Skin;
import com.badlogic.gdx.scenes.scene2d.ui.TextButton;
import com.badlogic.gdx.scenes.scene2d.utils.ChangeListener;

import zero1hd.rhythmbullet.controls.KeyMap;
import zero1hd.rhythmbullet.graphics.ui.components.ControlOptions;

public class KeybindOptionsPage extends Page {
	private ControlOptions controlTable;
	private KeyMap keyMap;
	private TextButton backButton;
	public KeybindOptionsPage(Skin skin, AssetManager assets, Vector3 cameraPosition) {
		setTextureBackground(assets.get("gradients.atlas", TextureAtlas.class).findRegion("red-round"));
		keyMap = new KeyMap(assets);
		controlTable = new ControlOptions(skin, keyMap);
		
		addActor(controlTable);
		
		backButton = new TextButton("Back", skin);
		backButton.setPosition(10, getHeight() - 10 - backButton.getHeight());
		backButton.setWidth(backButton.getWidth() + 20);
		backButton.addListener(new ChangeListener() {
			
			@Override
			public void changed(ChangeEvent event, Actor actor) {
				cameraPosition.y = 0.5f*getHeight();
			}
		});
		
		addActor(backButton);
	}
	
	public void unselect() {
		controlTable.unselect();
	}
}
